#!/usr/bin/env python
# coding=utf-8

import random
#-----------------------------------------------------------------------
# CREATION POPULATION
#-----------------------------------------------------------------------
def CreationPopulation(n,b): # n taille de l'echantillon, b nb de bytes
    liste = []
    for i in range(0,n) :
        temp = []
        for j in range(1,b):
            temp.append(j) 
        random.shuffle(temp)
        temp2 = [0]
        temp2.extend(temp)
        liste.append(temp2)
    return liste
#---------------------------------------------------------------------
# LECTURE MATRICE FICHIER
#---------------------------------------------------------------------
def LireMatrice(name):
    fichier = open(name,"r")    
    Matrix = []
    for i in fichier:
        ligne = i.split()
        ligne[len(ligne)-1] = ligne[len(ligne)-1].rstrip('\n')
        for j in range(0,len(ligne)):
            ligne[j] = int(ligne[j])
        Matrix.append(ligne)
    fichier.close()
    return Matrix    
#---------------------------------------------------------------------
# NOUVELLE POPULATION
#---------------------------------------------------------------------
def NouvellePopulation(pop):
    length = len(pop[0])
    for i in range(0,len(pop)/2):
        pfils = []
        sfils = []
    
        for j in range(0,random.randint(2,length-2)):
            pfils.append(pop[i*2][j])
            sfils.append(pop[i*2+1][j])
        for j in range (0,length):
            sfils.append(pop[i*2][j])
            pfils.append(pop[i*2+1][j])        
        sfils = nub(sfils)
        pfils = nub(pfils)
        MutationIndividu(sfils)
        MutationIndividu(pfils)
        
        pop[i*2] = sfils
        pop[i*2+1] = pfils
            
    return pop
#---------------------------------------------------------------------
# ENLEVER DOUBLONS
#--------------------------------------------------------------------- 
def nub(inpt):
    seen = set()
    out = []
    for item in inpt:
        if item not in seen:
            seen.add(item)
            out.append(item)
    return out   
    
#---------------------------------------------------------------------
# SELECTION POPULATION
#--------------------------------------------------------------------- 
def SelectionPopulation(pop,matCout):
    random.shuffle(pop);
    leng = len(pop[0])    
    note = [[0] * 2 for _ in range(len(pop))]
    for i in range(0,len(pop)):
        cout = 0
        for j in range(0,leng-1):
            cout += matCout[pop[i][j]][pop[i][j+1]]
        cout += matCout[0][pop[i][j+1]]
        note[i][1]=i
        note[i][0]=cout
    note.sort()
    print note[0][0]
    poptrie = []
    for k in range(0,len(note)/2):
        poptrie.append(pop[note[k][1]])
    
    return poptrie
#---------------------------------------------------------------------
# MUTATION D INDIVIDU
#--------------------------------------------------------------------- 
def MutationIndividu(ind):
    mutation = 50
    if (random.randint(1,100)<mutation):
        x = random.randint(1,41)
        y = random.randint(1,41)
        temp = ind[x]
        ind[x] = ind[y]
        ind[y] = temp
       
#---------------------------------------------------------------------
# MAIN PROGRAM
#---------------------------------------------------------------------

#Chargement de la matrice des couts
MatriceCout = LireMatrice("/home/eisti/Documents/Python/matrice3.txt")
#Creation de la population
population = CreationPopulation(50,42)
#Itterations
for i in range(0,250):
    #Creation de la nouvelle population fille
    newpopulation = NouvellePopulation(list(population))
    #Ajout a l'ancienne
    population.extend(newpopulation)
    #Selection de la meilleure population
    populationSelect = SelectionPopulation(list(population),MatriceCout)
    population = list(populationSelect)
    
#Fin des itterations et affichage de la meilleure solution
print "population"   
print population[0]
