#!/usr/bin/env python
# coding=utf-8

import copy
import time
import sys


fichier = open("test.txt","r")
Matrix = []
T = 1000
for i in fichier:
    i.strip()
    ligne = i.split("\t")
    ligne[len(ligne)-1] = ligne[len(ligne)-1].rstrip('\n')
    for j in range(0, len(ligne)):
    	ligne[j] = int(ligne[j])
    Matrix.append(ligne)
fichier.close()

class Noeud:
    def __init__(self):
        self.Matrix=[]
        self.cout=0
        self.parent=Noeud


    def _get_Matrix(self):
        return self._Matrix

    def _get_cout(self):
        return self._cout

    def _get_parent(self):
        return self._parent

    def _set_Matrix(self,Matrix):
        self._Matrix = Matrix
        
    def _set_cout(self,cout):
        self._cout = cout

    def _set_parent(self,parent):
        self._parent = parent

    def __eq__(self,other):
        for i,elt in enumerate(self.Matrix):
            for j,elt2 in enumerate(self.Matrix[i]):
                if (elt2!=other.Matrix[i][j]):
                    return False
        return True

    def __copy__(self):
        #new._Matrix = copy.deepcopy(self._Matrix)
        new = Noeud()
        new.Matrix = Noeud.copyMatrix(self)
        new.cout = self.cout
        new.parent = self.parent
        '''new.Matrix = copy.deepcopy(self.Matrix)
        new.cout = copy.deepcopy(self.cout)
        new.parent = copy.deepcopy(self.parent)'''
        return new


    def copyMatrix(self):
        newList = []
        for i,elt in enumerate(self.Matrix):
            newList.append(list(elt))
        return newList
            

def findPosZero(node):
    for i,elt in enumerate(node.Matrix):
        for j,elt2 in enumerate(node.Matrix[i]):
            if (elt2==0):
                  return i,j


                
def findNeighbors(node,objectif,openList,closedList):
    x,y = findPosZero(node)
    length=len(node.Matrix)
    width=len(node.Matrix[0])
    
    neighbors = []

    if ((x-1)>=0):
        tempNode = Noeud()
        tempNode.Matrix = Noeud.copyMatrix(node)
        temp=tempNode.Matrix[x-1][y]
        tempNode.Matrix[x][y]=tempNode.Matrix[x-1][y]
        tempNode.Matrix[x-1][y]=0
        inOpenList=findInOpenList(openList,tempNode)
        if(not(findInClosedList(closedList,tempNode))):
            tempNode.parent=node
            costFromDepToCurrentNode=node.cout+heuristiqueManhattan(tempNode,node)
            costFromCurrentNodeToObj=heuristiqueManhattan(tempNode,objectif)
            #costFromDepToCurrentNode=node.cout+heuristiqueNbCases(tempNode.Matrix,node.Matrix)
            #costFromCurrentNodeToObj=heuristiqueNbCases(tempNode.Matrix,objectif.Matrix)
            tempNode.cout += costFromDepToCurrentNode+costFromCurrentNodeToObj
            if(inOpenList[0]):
                if (inOpenList[2].cout>(tempNode.cout)):
                    openList[inOpenList[1]]=tempNode
            else:
                neighbors.append(copy.copy(tempNode))
        del tempNode

   
    if ((x+1)<length):
        tempNode = Noeud()
        tempNode.Matrix = Noeud.copyMatrix(node)
        temp=tempNode.Matrix[x+1][y]
        tempNode.Matrix[x][y]=tempNode.Matrix[x+1][y]
        tempNode.Matrix[x+1][y]=0
        inOpenList=findInOpenList(openList,tempNode)
        if(not(findInClosedList(closedList,tempNode))):
            tempNode.parent=node
            costFromDepToCurrentNode=node.cout+heuristiqueManhattan(tempNode,node)
            costFromCurrentNodeToObj=heuristiqueManhattan(tempNode,objectif)
            #costFromDepToCurrentNode=node.cout+heuristiqueNbCases(tempNode.Matrix,node.Matrix)
            #costFromCurrentNodeToObj=heuristiqueNbCases(tempNode.Matrix,objectif.Matrix)
            tempNode.cout += costFromDepToCurrentNode+costFromCurrentNodeToObj
            if(inOpenList[0]):
                if (inOpenList[2].cout>(tempNode.cout)):
                    openList[inOpenList[1]]=tempNode
            else:
                neighbors.append(copy.copy(tempNode))
        del tempNode

    if ((y-1)>=0):
        tempNode = Noeud()
        tempNode.Matrix = Noeud.copyMatrix(node)
        temp=tempNode.Matrix[x][y-1]
        tempNode.Matrix[x][y]=tempNode.Matrix[x][y-1]
        tempNode.Matrix[x][y-1]=0
        inOpenList=findInOpenList(openList,tempNode)
        if(not(findInClosedList(closedList,tempNode))):
            tempNode.parent=node
            costFromDepToCurrentNode=node.cout+heuristiqueManhattan(tempNode,node)
            costFromCurrentNodeToObj=heuristiqueManhattan(tempNode,objectif)
            #costFromDepToCurrentNode=node.cout+heuristiqueNbCases(tempNode.Matrix,node.Matrix)
            #costFromCurrentNodeToObj=heuristiqueNbCases(tempNode.Matrix,objectif.Matrix)
            tempNode.cout += costFromDepToCurrentNode+costFromCurrentNodeToObj
            if(inOpenList[0]):
                if (inOpenList[2].cout>(tempNode.cout)):
                    openList[inOpenList[1]]=tempNode
            else:
                neighbors.append(copy.copy(tempNode))
        del tempNode

    if ((y+1)<width):
        tempNode = Noeud()
        tempNode.Matrix = Noeud.copyMatrix(node)
        temp=tempNode.Matrix[x][y+1]
        tempNode.Matrix[x][y]=tempNode.Matrix[x][y+1]
        tempNode.Matrix[x][y+1]=0
        inOpenList=findInOpenList(openList,tempNode)
        if(not(findInClosedList(closedList,tempNode))):
            tempNode.parent=node
            costFromDepToCurrentNode=node.cout+heuristiqueManhattan(tempNode,node)
            costFromCurrentNodeToObj=heuristiqueManhattan(tempNode,objectif)
            #costFromDepToCurrentNode=node.cout+heuristiqueNbCases(tempNode.Matrix,node.Matrix)
            #costFromCurrentNodeToObj=heuristiqueNbCases(tempNode.Matrix,objectif.Matrix)
            tempNode.cout += costFromDepToCurrentNode+costFromCurrentNodeToObj
            if(inOpenList[0]):
                if (inOpenList[2].cout>(tempNode.cout)):
                    openList[inOpenList[1]]=tempNode
            else:
                neighbors.append(copy.copy(tempNode))
        del tempNode
    del node
    return neighbors


def heuristiqueManhattan(current,objectif):
    x_Objectif,y_Objectif = findPosZero(objectif)
    x_Current,y_Current = findPosZero(current)


    x = (x_Objectif - x_Current) if (x_Objectif > x_Current) else (x_Current - x_Objectif)
    y = (y_Objectif - y_Current) if (y_Objectif > y_Current) else (y_Current - y_Objectif)
    return x + y

def heuristiqueNbCases(current,objectif):
    badCases=0
    listCurrent=[]
    listObjectif=[]
    
    for i,elt in enumerate(current):
        listCurrent.extend(elt)
    for j,elt in enumerate(objectif):
        listObjectif.extend(elt)
    for k in range(0,len(listCurrent)):
            if(listCurrent[k]!=listObjectif[k]):
                badCases+=1
    return badCases
    
def findBestNode(openList):
    temp=[]
    for i,elt in enumerate(openList):
        if(currentCost<cout):
            cout=currentCost
            best=elt
    return best



def findInClosedList(closedList,neighbor):
    for i,elt in enumerate(closedList):
        '''if (elt==neighbor):
            return True'''
        if(elt.Matrix==neighbor.Matrix):
            return True
    return False


def findInOpenList(openList,neighbor):
    if (len(openList)!=0):
        for i,elt in enumerate(openList):
            if(elt.Matrix==neighbor.Matrix):
                return [True,i,elt]
    return [False,None,None]

def A_Star(Matrix):
    print("Processing")
    print(Matrix)

    objectif=Noeud()
    objectif.Matrix=Soluce(Matrix)

    depart = Noeud()
    depart.Matrix=Matrix
    depart.cout=heuristiqueNbCases(depart.Matrix,objectif.Matrix)

    openList = []
    closedList = []
    
    openList.append(copy.copy(depart))
    closedList.append(copy.copy(depart))
    
    sol=False

    while(len(openList)!=0 and len(closedList)!=0):
        global step
        step+=1
        #print(step)
        node=openList.pop()

        if(node.Matrix==objectif.Matrix):
            print("Solution trouvée")
            #closedList.append(node)
            sol=True
            break
        else:
            neighbors=findNeighbors(node,objectif,openList,closedList)
            for i,elt in enumerate(neighbors):
                openList.append(elt)

            openList.sort(key=lambda x: x.cout, reverse=True)

            if (len(openList)==0):
                print("Pas de solution trouvée")
                break
            else:                
                closedList.append(openList[-1])

        
    print("FINISH")  
    closedList.sort(key=lambda x: heuristiqueNbCases(x.Matrix,objectif.Matrix), reverse=True)
    print(closedList[-1].Matrix)
    print(closedList[-1].cout)
    
    if(sol):
        #Fonction reconstitution chemin
        print("Reconstitution du chemin ...")
        chemin,solution=findChemin(closedList,depart,objectif)
        chemin.reverse()
        #print(chemin)
        with open("result.txt", "w") as variable:
            #larg = len(node.Matrix[0])
            for i,elt in enumerate(chemin):
                variable.write(elt+"\n")

            '''for i,elt in enumerate(solution):
                for j,elt2 in enumerate(elt.Matrix):
                    for k,elt3 in enumerate(elt2):
                        variable.write(str(elt3)+"  ")
                        if k%larg-1==0 and k!=0:
                            variable.write("\t")
                    variable.write("\n")
                variable.write("\n")
                variable.write(chemin[i]+"\n")
                variable.write("\n")'''
        




                




def printMatrix(Matrix):
    print("")

def findChemin(closedList,depart,objectif):
    node=closedList[-1]
    chemin = []
    listeSolution = []
    #test=[]
    while(node.Matrix!=depart.Matrix):
        '''if(node.Matrix!=objectif.Matrix):'''
        parent=node.parent
        xNode,yNode = findPosZero(node)
        xParent,yParent = findPosZero(parent)
        if(xNode==xParent):
             if(yNode>yParent):
                 direction="b " #g
             elif (yNode<yParent):
                 direction="h " #r
        elif(yNode==yParent):
            if(xNode>xParent):
                 direction="g " #h
            elif(xNode<xParent):
                direction="d " #b
        chemin.append(direction)
        listeSolution.append(node)
        node=node.parent
    #chemin.reverse()
    #test.reverse()
    #print(test)
    listeSolution.reverse()
    return chemin,listeSolution


        
        

def Soluce(Matrix):
    long = len(Matrix)
    larg = len(Matrix[0])
    l=[]
    sub=[]
    for i in range(1,long*larg+1):
        sub.append(i)
        if i%larg==0:
            l.append(sub)
            sub=[]
    l[-1][-1]=0
    return l

step=0

print(Soluce(Matrix))

time1 = time.clock()
sys.setrecursionlimit(100000)
A_Star(Matrix)
time2 = time.clock()

print("{} steps in {} seconds".format(step, (time2-time1)))







